EDIT - bug #8783

Massive Heap consumption in server instance opening the Description-Matrix editor
12/18/2019 02:43 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: New Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.15

Severity: critical Found in Version:

Description

This was observed with a locally running cdmlib-remote-webapp instance configured with 700 MB of Heap:
Left pane shows the cdmlib-remote-webapp instance®*, right pane the Taxeditor.

[caryophyllales_spp] 14:34:40,792 WARN [gtp759156157-23] [or.sp.re.su.RemoteInvocationTracelntercep
tor] - Processing of HttpInvokerServiceExporter remote call resulted in fatal exception: eu.etaxon
omy.cdm.api.service.IService.load
java.lang.OutOfMemoryError: GC overhead limit exceeded

at java.util.HashMap.newNode (HashMap. java:1742)

at java.util.HashMap.putVal (HashMap. java:630)

at java.util.HashMap.put (HashMap. java:611)

at java.util.HashSet.add(HashSet.java:219)

at java.util.AbstractCollection.addAll (AbstractCollection. java:344)

at org.hibernate.collection.internal.PersistentSet.endRead(PersistentSet.java:327)

at org.hibernate.engine.loading.internal.CollectionLoadContext.endLoadingCollection (Collection
LoadContext. java:234)

at org.hibernate.engine.loading.internal.CollectionLoadContext.endLoadingCollections (Collectio
nLoadContext.java:221)

at org.hibernate.engine.loading.internal.CollectionLoadContext.endLoadingCollections (Collectio
nLoadContext. java:194)

at org.hibernate.loader.Loader.endCollectionLoad (Loader.java:1179)

at org.hibernate.loader.Loader.initializeEntitiesAndCollections (Loader. java:1143)

at org.hibernate.loader.Loader.processResultSet (Loader.java:992)

at org.hibernate.loader.Loader.doQuery (Loader.java:930)

at org.hibernate.loader.Loader.doQueryAndInitializeNonLazyCollections (Loader. java:336)

at org.hibernate.loader.Loader.dolList (Loader.java:2611)

at org.hibernate.loader.Loader.dolList (Loader.java:2594)

at org.hibernate.loader.Loader.listIgnoreQueryCache (Loader. java:2423)

at org.hibernate.loader.Loader.list (Loader.java:2418)

at org.hibernate.loader.hgl.QueryLoader.list (QueryLoader.java:501)
hgl.internal.ast.QueryTranslatorImpl.list (QueryTranslatorImpl.java:371)

engine.query.spi.HQLQueryPlan.performList (HQLQueryPlan.

internal.SessionImpl.list (SessionImpl.java:1326)
internal.QueryImpl.list (QueryImpl.java:87)
At the test-server it takes ~700MB to load the matrix data without garbage collection
Related issues:
Related to EDIT - bug #8785: Move functionality of buttons to context menu of...
Related to EDIT - bug #9029: Adapt character matrix to using dtos instead of ...
Related to EDIT - bug #9820: OptionalDataException when saving character matrix

Resolved
Closed
New

History

#1 - 12/18/2019 03:03 PM - Andreas Kohlbecker
- File picture521-1.png added

- Description updated

#2 - 12/19/2019 02:30 PM - Andreas Miiller

- Target version changed from Unassigned CDM tickets to Release 5.13

As this is a critical issue | suggest to put it into 5.13. (5.12 is probably not possible as the task is difficult). We may then discuss who will care for it.

#3 - 03/09/2020 04:29 PM - Andreas Miuller

- Target version changed from Release 5.13 to Release 5.14

#4 - 03/31/2020 11:26 AM - Katja Luther

- Target version changed from Release 5.14 to Release 5.15

#5 - 05/19/2020 02:21 PM - Katja Luther
- File picture701-1.png added

- Status changed from New to In Progress

The implementation for the rowWrappers changed, having a look at the consumption shows a smaller heap (opening the character matrix two times):

C localhost:3333 (pid 9772)

Monitor CPU Memory Classes Threads
Uptime: 8 min 29 sec Perform GC Heap Dump
cru % | | Heap | Metaspace x
CPU usage: 38.7% GC activity: 0.8% Size:631,242,7528 Used: 250,255,008 B
N Max: 652,738,560 B
100%
-
o0 me
400 ME

0% 200
0%
100 MB-
10%
o A A oM

“ 146 P 1:47 PM 1:48 PM 1:48 PM 1:50 PM T nae P 1:47 PM 1:48 PM 1:49 PM 1:50 PM
[ CPUusage [ GC activity [ Heap size W Used heap

#6 - 05/26/2020 01:49 PM - Katja Luther
- File deleted (picture701-1.png)

#7 - 05/26/2020 01:49 PM - Katja Luther
- File picture071-1.png added

#8 - 05/26/2020 02:35 PM - Katja Luther
- Status changed from In Progress to Resolved

- Assignee changed from Katja Luther to Andreas Kohlbecker

This seems to be fixed.

#9 - 06/09/2020 06:02 PM - Andreas Kohlbecker

from the diagrams it really looks like this problem is fixed. Can you please link the rowWrappers-Ticket with this one?

#10 - 06/18/2020 02:02 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Katja Luther

please see the last comment

#11 - 06/18/2020 02:08 PM - Katja Luther

- Related to bug #8785: Move functionality of buttons to context menu of the character matrix added

#12 - 06/18/2020 02:09 PM - Katja Luther

- Related to bug #9029: Adapt character matrix to using dtos instead of whole cdm entities added

#13 - 06/18/2020 04:04 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Kohlbecker

| added the relevant tickets

#14 - 06/18/2020 04:35 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Katja Luther

Thank you, | think we can close this ticket now.
#15 - 06/19/2020 09:53 AM - Katja Luther

- Status changed from Resolved to Closed

#16 - 10/18/2021 12:44 PM - Katja Luther

- Status changed from Closed to In Progress

#17 - 10/18/2021 12:54 PM - Andreas Miiller

If we reopen then we should adapt the milestone. But maybe it is better to keep this closed and create a new ticket as the problem is probably not as
big as before anymore (if it exists at all, which is not sure).

#18 - 10/18/2021 01:51 PM - Andreas Kohlbecker

- Status changed from In Progress to Feedback

Was comment 16 ("changed from Closed to In Progress") a mistake, it completely misses any explanation?
| am assuming that this ticket is fully solved.

#19 - 10/18/2021 02:02 PM - Katja Luther
- Status changed from Feedback to Closed

Actually maybe this was the wrong ticket because the exception coming up again was not an OutOfMemoryException but an OptionalDataException.
| think we should open a new ticket for this.

#20 - 10/19/2021 10:39 AM - Andreas Miiller

Katja Luther wrote:
Actually maybe this was the wrong ticket because the exception coming up again was not an OutOfMemoryException but an
OptionalDataException. | think we should open a new ticket for this.

Did you open a new ticket? | can't see any.

Also OptionalDataException is probably related to OutOfMemoryException as you (see #9358) so there is a good chance that there is the same
reason for both problems. Please relate new ticket to both this ticket and #9358.

#21 - 10/19/2021 11:19 AM - Katja Luther

- Related to bug #9820: OptionalDataException when saving character matrix added

Files

picture321-1.png 64.2 KB 12/18/2019 Andreas Kohlbecker
picture521-1.png 9.92 KB 12/18/2019 Andreas Kohlbecker
picture071-1.png 54.7 KB 05/26/2020 Katja Luther
